--[[

How to utilize Crabby:

1.  Crabby:Say ("Hello world!")

2.  Crabby:Ask ("Do you want to ninja the loot?",
    {
            {text="Yes!", param=1},
            {text="No!", param=2},
            {text="Maybe!", param=3},
        },
        function (param)
            print(param)
        end
    )





]]

local PATH = 'Interface\\Addons\\Crabby\\%s'
local MAX_BUBBLE_W = 250

local TEXT_DISTANCE_FROM_CRABBY = 60
local OPTIONS_DISTANCE = 10
local OPTIONS_DISTANCE_FROM_TEXT = 2
local MAX_OPTIONS = 10

local DO_NOT_HIDE = -1
local Crabby

------------------------------------------------------------------

pearlsOfWisdom = {
    ['money'] = {
        'Remember, a copper saved is a copper earned!',
        'They say that gold is the root of all evil.',
        "Don't spend all your gold! Save some for a raidy day.",
        'They say a noob and his gold are soon parted.',
        'Can you believe the prices here?!',
        'A goblin always pays his debts!',
        'Can you buy a pet crab so I have someone to play with?',
        'Ooh, the auction house! Are you going to buy me a present?',
    },
    ['xmog'] = {
        'You look absolutely fabulous!',
        'You look great in that!',
        "Can I borrow that shirt? I'm going to a party later.",
        'Are you sure about these shoulders? Maybe you should try a smaller size...',
        'This belt with those shoes? Seriously?',
        'I think this makes you look fat. There, I said it.',        
    },
    ['joke'] = {
        'Yo momma is so fat, when she stands in Orgrimmar I can melee her from Stormwind!',
        'Yo momma is so fat, chain lightning hits her 3 times!',
        'Yo momma is so stupid, she does stand in the fire!',
        'How many rogues does it take to kill a paladin?|n|nTwo, one to attack and one to wait at the inn!',
        -- I don't know, should in include some Chuck Norris facts here...? Or is it unfunny enough as it is?
        'You know you\'re addicted to WoW when the microwave goes "Ding!" and you reply "Grats!"',
    },
    ['bored'] = {
        "I'm bored. Let's go kill a dragon!",
        
    },
    ['greet'] = {
        'Greetings, master!',
        'Hey buddy!',
        'Oh, hai!',
        'Hello there!',
        'Hey pal!',
        'I used to be a raid boss, you know, until I took an arrow to the... ummm... claw.',
        'Why are you poking me?',
        'Good morning!',
        "Not now, I'm busy.",
        'Zug-zug?',
    },
    ['epix'] = {
        'Yay, epics!',
        "You're just going to disenchant that, aren't you?",
        'Why do you always get the loot?',
        'Ooh, shiny!',
    },
    ['epix_ask'] = {
        {
            'Can I have that for my off-spec?',
            { {text="Sure thing!", param=1}, {text="No, it's mine!", param=2}, },
            function (param)
                if param==1 then
                    Crabby:Say ("Ummm... never mind, I'm too low level.")
                elseif param==2 then
                    Crabby:Say ("Fine. I didn't want it anyway.")
                end
            end
        },
        
        {
            'Can I have that for transmog?',
            { {text="Sure thing!", param=1}, {text="No, it's mine!", param=2}, },
            function (param)
                if param==1 then
                    Crabby:Say ("Thanks! I'll be the best-looking crab in Azeroth!")
                elseif param==2 then
                    Crabby:Say ("Whatever, it's ugly anyway.")
                end
            end
        },
    },
    ['legendary'] = {
        'Woah, legendary! Grats, man!',
        "I already have one of those. It's in the bank. Really.",
        "I can't believe it took you this long!",
        "I'm jealous.",
    },
    
    ['engineering'] = {
        'When will you learn how to build a samophlange?',
        'You should spec in software engineering.',
        
    },
    
}

local function RandomPearlOfWisdom (category)
    return pearlsOfWisdom[category][random(#pearlsOfWisdom[category])]
end


local instructions = {
    AUCTION_HOUSE_SHOW =    {odds = 7, tag = 'money'},
    TRANSMOGRIFY_SUCCESS =  {odds = 3, tag = 'xmog'},
    --CHAT_MSG_LOOT =         {odds = 6, tag = 'epix'},
}

local function ItIsTimeToSpeak (chance)
    return random(chance)==1
end

------------------------------------------------------------------

local function OnEvent_SkillMessage (msg)
    local prof, rank = msg:match('Your skill in ([^ ]+) has increased to (%d+)')
    prof = prof:lower()
    
    if ItIsTimeToSpeak(5) and pearlsOfWisdom[prof] then
        Crabby:Say (RandomPearlOfWisdom (prof))
    end
end

------------------------------------------------------------------
------------------------------------------------------------------

local crabbyCoords_X = {0.01, 0.1955, 0.381, 0.5667, 0.7524}
local crabbyCoords_Y = {0, 0.1265, 0.2516, 0.3749, 0.5029, 0.6268}
local crabbyCoord_W = 0.17
local crabbyCoord_H = 0.1245

do 
    Crabby = CreateFrame("Frame", "Crabby", UIParent)
    Crabby:SetPoint ("LEFT", UIParent, "LEFT", 100, -200)
    Crabby:SetSize (160,120)

    Crabby:SetMovable (true)
    Crabby:SetUserPlaced (true)
    Crabby:SetScript ("OnMouseDown", function (self, button,...)
        if button=='LeftButton' then
            self:StartMoving ()
        elseif button=='RightButton' then
            frmCrabbyBubble:Hide()
            --[[self:Ask (
                RandomPearlOfWisdom ('greet'),
                {
                    {param=1, text= 'How are you?'},
                    {param=2, text= 'Tell me a joke'},
                    {param=3, text= 'Can you help me kill a raid boss?'},
                },
                function (param)
                    if param==1 then
                    
                    elseif param==2 then
                        self:Say (RandomPearlOfWisdom ('joke'))
                    elseif param==3 then
                        self:Say ("I'm sorry, but the Crabby Code of Conduct forbids me to kill a boss for you.")
                    end
                end
            )]]
            self:Say (RandomPearlOfWisdom ('greet'))
        end
    end)
    Crabby:SetScript ("OnMouseUp", function (self, button,...)
        self:StopMovingOrSizing()
    end)
        
    Crabby.tex = Crabby:CreateTexture ("Texture", "HIGH")
    Crabby.tex:SetAllPoints (Crabby)
    Crabby.tex:SetTexture (PATH:format("crabby"))
    Crabby.tex:SetTexCoord (crabbyCoords_X[1], crabbyCoords_X[1] + crabbyCoord_W, crabbyCoords_Y[1], crabbyCoords_Y[1] + crabbyCoord_H)

    Crabby.elapsed = 0
    Crabby.frameDuration = 0.047
    Crabby.coordX = 1
    Crabby.coordY = 1
    Crabby:SetScript ("OnUpdate", function (self, elapsed)
        self.elapsed = self.elapsed + elapsed
        if self.elapsed > self.frameDuration then
            self.elapsed = 0
            
            self.coordX = self.coordX + 1
            if self.coordX > #crabbyCoords_X then
                self.coordX = 1
                self.coordY = self.coordY + 1
            end
            if self.coordY > #crabbyCoords_Y then
                self.coordY = 1
            end
            
            self.tex:SetTexCoord (
                crabbyCoords_X[self.coordX],
                crabbyCoords_X[self.coordX] + crabbyCoord_W,
                crabbyCoords_Y[self.coordY],
                crabbyCoords_Y[self.coordY] + crabbyCoord_H
            )
        end
    end)
    
    Crabby:SetScript ("OnEnter", function (self,...)
        SetCursor('SPEAK_CURSOR')
    end)
    Crabby:SetScript ("OnLeave", function (self,...)
        ResetCursor()
    end)
end

------------------------------------------------------------------
local function InitFontstring (f)
    f:SetTextColor (0,0,0)
    f:SetFont (PATH:format("comicsans.ttf"), 14)
    f:SetShadowColor (0,0,0,0)
    f:SetDrawLayer ("OVERLAY")
    f:SetJustifyH ("LEFT")    
end

------------------------------------------------------------------

do
    local radius = 18
    local margin = radius-8
    local margin_outline = margin + 1
    local color = {0.8, 0.75, 0.55}
    local color_outline = {0,0,0}
        
    local f = CreateFrame ("Frame", 'frmCrabbyBubble', Crabby)
    f:Hide()
    f.outline = CreateFrame ("Frame", nil, f)
    f:SetBackdrop ({
        bgFile = PATH:format("white"),
        edgeFile = PATH:format("balloon"),
        edgeSize = radius,
        insets = {left=radius, right=radius, top=radius, bottom=radius}
    })
    f:SetBackdropColor (unpack(color))
    f:SetBackdropBorderColor (unpack(color))

    -- The text:
    f.txt = f:CreateFontString (nil, "BACKGROUND", "GameFontNormal")
    f.txt:SetWidth (250)
    f.txt:SetPoint ("BOTTOM", Crabby, "TOP", 20, TEXT_DISTANCE_FROM_CRABBY)
    InitFontstring (f.txt)
    
    f:SetPoint ("TOPLEFT", f.txt, "TOPLEFT", -margin, margin)
    f:SetPoint ("RIGHT", f.txt, "RIGHT", margin, 0)
    f:SetPoint ("BOTTOM", f.txt, "BOTTOM", 0, -margin-2)
    
    -- Options
    f.options = {}
    f.options[0] = CreateFrame ("Frame", f)
    f.options[0].txt = CreateFrame ("Frame", f)
    f.options[0].txt:SetSize (1,OPTIONS_DISTANCE_FROM_TEXT)
    f.options[0].txt:SetPoint ("TOPRIGHT", f.txt, "BOTTOMRIGHT")
    
    local tmp
    for i=1,MAX_OPTIONS do
        tmp = CreateFrame ("Frame", nil, f)
        tmp.txt = tmp:CreateFontString (nil, "BACKGROUND", "GameFontNormal")
        tmp.txt:SetPoint ("TOPRIGHT", f.options[i-1].txt, "BOTTOMRIGHT", 0, -OPTIONS_DISTANCE)
        tmp.txt:SetPoint ("LEFT", f.txt, "LEFT", 20, -4)
        tmp:SetAllPoints (tmp.txt)
        InitFontstring (tmp.txt)
        
        tmp.circle = tmp:CreateTexture ("Texture")
        tmp.circle:SetTexture (PATH:format("circle"))
        tmp.circle:SetSize (10,10)
        tmp.circle:SetPoint ("TOPRIGHT", tmp.txt, "TOPLEFT", -8, -1)
        
        f.options[i] = tmp
        --tmp:Hide()
    end
    
    -- The bubble's... err... pointy bit
    f.point = f:CreateTexture ("Texture")
    f.point:SetSize (45,45)
    f.point:SetPoint ("TOP", f, "BOTTOM", 10, 0)
    f.point:SetTexture (PATH:format("balloon2"))
    f.point:SetVertexColor (unpack(color))

    -- The outline
    f.outline:SetBackdrop ({
        bgFile = PATH:format("white"),
        edgeFile = PATH:format("balloon"),
        edgeSize = radius,
        insets = {left=radius, right=radius, top=radius, bottom=radius}
    })
    f.outline:SetBackdropColor (unpack(color_outline))
    f.outline:SetBackdropBorderColor (unpack(color_outline))
    f.outline:SetPoint ("TOPLEFT", f, "TOPLEFT", -1, 2)
    f.outline:SetPoint ("BOTTOMRIGHT", f, "BOTTOMRIGHT", 1, -2)
    f.outline:SetFrameStrata("BACKGROUND")
    
    -- Events
    f:SetScript ("OnMouseDown", function (self, button)
        if button=="RightButton" then
            self:Hide()
        end
    end)
    
    
    -- Animation stuff
    f.animGroup = f:CreateAnimationGroup()
    
    f.animAlpha = f.animGroup:CreateAnimation("Alpha")
    f.animAlpha:SetChange (-1)
    f.animAlpha:SetDuration (0.5)
    f.animAlpha:SetSmoothing("IN")
    f.animAlpha:SetOrder (1)

    f.animGroup:SetScript ("OnFinished", function (self, requested)
        frmCrabbyBubble:Hide()
    end)
    
    ----------------------------------------
    
    function Crabby:Say (txt, duration)
        local bubble = frmCrabbyBubble
        if bubble:IsShown() then return end
        
        bubble.txt:SetText (txt)
        bubble.txt:SetWidth (max(bubble.txt:GetStringWidth(), 120))
        bubble.txt:SetWidth (min(bubble.txt:GetWidth(), 200))
        
        bubble.txt:SetPoint ("BOTTOM", Crabby, "TOP", 20, TEXT_DISTANCE_FROM_CRABBY)
        
        bubble:SetPoint ("BOTTOM", bubble.txt, "BOTTOM", 0, -margin-2)
        for k,v in pairs(bubble.options) do
            v:Hide()
        end
    
        bubble:Show()
        
        if duration ~= DO_NOT_HIDE then
            f.animAlpha:SetStartDelay (duration or 6)
            bubble.animGroup:Stop ()
            bubble.animGroup:Play ()
        end
    end
    ----------------------------------------
    
    function Crabby:Say_Random (event)
        self:Say (RandomPearlOfWisdom (instructions[event].tag))
    end
    ----------------------------------------    
    
    function Crabby:ShutUp ()
        frmCrabbyBubble:Hide()
    end
    
    function Crabby:Ask (txt, tblOptions, func)
        -- tblOptions is a table that looks like:  tblOptions = { {text="Yes", param=1} ,  {text="No", param=2} }
        -- func will be called once the user picks an option, and receive param
        local bubble = frmCrabbyBubble
        self:Say (txt, DO_NOT_HIDE)
        self.func = func
        
        bubble:SetPoint ("BOTTOM", bubble.options[#tblOptions].txt, "BOTTOM", 0, -margin-2)

        local dist = TEXT_DISTANCE_FROM_CRABBY + OPTIONS_DISTANCE_FROM_TEXT
        
        bubble.options[0]:Show()
        for i,v in ipairs(tblOptions) do
            bubble.options[i].txt:SetText (v.text)
            bubble.options[i].txt:SetHeight (bubble.options[i].txt:GetStringHeight() * math.ceil (bubble.options[i].txt:GetStringWidth() / bubble.options[i].txt:GetWidth()))
            bubble.options[i].val = v.param
            bubble.options[i]:SetScript ("OnMouseDown", function (self, button)
                if button=="LeftButton" then
                    frmCrabbyBubble:Hide ()
                    Crabby.func (self.val)
                end
            end)
            bubble.options[i]:Show()
            dist = dist + OPTIONS_DISTANCE + bubble.options[i].txt:GetHeight()
        end
        
        bubble.txt:SetPoint ("BOTTOM", Crabby, "TOP", 20, dist)        
    end
end

--Crabby:Say ('Hello! I am Crabby, the dungeon helper!')


------------------------------------------------------------------
-- Events!

Crabby:RegisterEvent ('AUCTION_HOUSE_SHOW')
Crabby:RegisterEvent ('AUCTION_HOUSE_CLOSED')
Crabby:RegisterEvent ('TRANSMOGRIFY_SUCCESS')
Crabby:RegisterEvent ('CHAT_MSG_LOOT')
Crabby:RegisterEvent ('CHAT_MSG_SKILL')
Crabby:RegisterUnitEvent ('UNIT_AURA', 'player')

Crabby:SetScript ("OnEvent", function (self, event, ...)
    if event=='CHAT_MSG_LOOT' then
        local s = select(1,...)
        local itemID = s:match ('\|[0-9a-f]+\|Hitem:([0-9]+).*\|h\|r')
                
        local name, link, quality = GetItemInfo(itemID) 
        if quality==4 and s:match ('You receive loot') then 
            if ItIsTimeToSpeak (6) then
                Crabby:Say_Random (event)
            elseif ItIsTimeToSpeak(5) then
                Crabby:Ask (unpack(pearlsOfWisdom['epix_ask'][random(#pearlsOfWisdom['epix_ask'])]))
            end
        end
    elseif event=='CHAT_MSG_SKILL' then
        if select(2,...)=='' then
            OnEvent_SkillMessage (select(1,...))
        end
    elseif event=='UNIT_AURA' then
        if UnitDebuff ('player', 'Spray Water') or UnitAura ('player', 'Goblin Glider') then
            Crabby:Say ('Wheeeeeeee!', 3)
        end
    elseif instructions[event] and ItIsTimeToSpeak (instructions[event].odds) then
        --Crabby:Say (RandomPearlOfWisdom (instructions[event].tag))
        Crabby:Say_Random (event)
    end
    
    
end)

------------------------------------------------------------------


